#ifndef INTE_MOD
#define INTE_MOD


#include"mbed.h"

class interruptin_mod: public InterruptIn{
    
    public:
    
        interruptin_mod(PinName pin);
        
        void fall_disable(void (*fptr)(void));
        void rise_disable(void (*fptr)(void));
        
        template<typename T>
        void rise_disable(T* tptr, void (T::*mptr)(void)) {
            _rise.attach(tptr, mptr);
            gpio_irq_set(&gpio_irq, IRQ_RISE, NULL);
        }        
        template<typename T>
        void fall_disable(T* tptr, void (T::*mptr)(void)) {
            _fall.attach(tptr, mptr);
            gpio_irq_set(&gpio_irq, IRQ_RISE, NULL);
            }
    

    };
    
#endif